/*********************************************
This program was produced by the
CodeWizardAVR V1.0.2.2d Standard
Automatic Program Generator
 Copyright 1998-2002
Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro , hpinfotech@xmail.ro

Project : TP4 Pousse Seringue
Version : 1
Date    : 03/2003
Author  : Philippe Mariano                
Company : LYCEE Pierre Emile MARTIN       
Comments: Rorganisation de la fonction traiter du PS


Chip type           : AT90S8535
Clock frequency     : 4,000000 MHz
Memory model        : Small
Internal SRAM size  : 512
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

#include <90s8535.h>

// Librairies non gnres par Wizard (rajoutes manuellement)      
#include <ssi.h>      // contient les fonctions Lire_BP,Affiche_LCD,Regdebit,Select_Seringue 
#include <delay.h>    // contient la fonction delay_ms
#include <stdio.h>    // contient la fonction sprintf

// Etats du graphe des transitions "Menu"
#define Arret	 	0
#define Marche	 	1
#define ReglageDebit	2    
#define ChoixSeringue	3

// Etats du graphe des transitions "Moteur"
#define etat0	0
#define etat1	1
#define etat2	2
#define etat3	3

// Code des BPs de la carte AT90S8535 SSI
#ifndef INC 
#define INC	0x1F  
#endif 
#ifndef DEC 
#define DEC	0x2F
#endif 
#ifndef OK
#define OK	0x37
#endif 
#ifndef ECHAP
#define ECHAP	0x3B
#endif 
#ifndef SET
#define SET	0x3D
#endif
#ifndef ENTR
#define ENTR	0x3E
#endif

// Types de seringue
#define Terumo50CC   	1
#define Monoject50CC    2
#define BD20CC          3

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>  


// Declare your global variables here
unsigned int Vtimer; // Rglage de la frquence du moteur pas  pas

// Timer 1 overflow interrupt service routine 
// Sous programme d'interruption "Moteur"
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
static unsigned char etat = etat0;
TCNT1 = Vtimer; // rechargement du timer 1
switch(etat) 
	{
       	  case etat0 : PORTB = 9; etat = etat1; break;
	  case etat1 : PORTB = 5; etat = etat2; break;						 
	  case etat2 : PORTB = 6; etat = etat3; break;
	  case etat3 : PORTB = 10; etat = etat0; break;
	  default: etat=etat0;	  
	} 
}

//--------------------
// Programme principal
//--------------------

void main(void)
{
// Declare your local variables here
//----------------------------------
char display_buffer_ligne0[17]; // tampon ligne 0 de l'afficheur
char display_buffer_ligne1[17]; // tampon ligne 1 de l'afficheur
float FPH; // frquence calcule  partir de la consigne de dbit
unsigned char etat = Arret, etat_1 = Marche; // variables du graphe Menu
unsigned char BP, seringue=1; // BP = code ou tat de la touche slectionne
			    // seringue = type de seringue slectionne 
unsigned int dizaines=0, unites=0, diziemes=0; // slection du dbit  dizaines unites.diziemes ml/h
unsigned int dix_C_debit; // dix_C_debit = 100*dizaines + 10*unites + diziemes


// Input/Output Ports initialization
// Port A
PORTA=0x3F;
DDRA=0x00;

// Port B
PORTB=0x00;      		       			
DDRB=0x1f;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 3,906 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x05;
TCNT1H=0xFF;
TCNT1L=0xFE;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// LCD module initialization
lcd_init(16);

// Global enable interrupts
#asm("sei")


while (1)
  {
      BP = Lire_BP();
      
      switch (etat)
      {
       case Arret : if (etat_1 != etat)
                       {
                        PORTB = 0x00;  // dsactivation du moteur
                        TIMSK=0x00; // inhibition interruption dbordement timer 1
                        sprintf(display_buffer_ligne0,"OK>RG_D ETR>CH_S");
                    	sprintf(display_buffer_ligne1,"SET -> RUN");
                    	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                       }
                    	if (BP==OK) etat = ReglageDebit;
                      		else if (BP==SET) etat = Marche;
                      	       		else if (BP==ENTR) etat = ChoixSeringue;
                      		               else etat = Arret;
       		    etat_1 = Arret; 
       break;
       		   
       case Marche : if (etat_1 != etat) 
                       { 
                          dix_C_debit = 100*dizaines + 10*unites + diziemes;
                         
                       	  switch (seringue)   // Calcul de FPH=f(C_debit)
                         	{
                         	 case Terumo50CC : FPH = (0.2*dix_C_debit)/10; break;
                          	 case Monoject50CC :FPH = (0.2378*dix_C_debit)/10; ; break; 				// <-  complter 
                          	 case BD20CC : FPH = (0.4667*dix_C_debit)/10; break;       				// <-  complter 
                         	} 
                           
                          Vtimer = 65536 - 4.0E6 / (4096*FPH) ; //calcul de la valeur initiale du timer1   	 // <-  complter 
                            
                          sprintf(display_buffer_ligne0,"DEDIT = %-u%-u.%-uml/h",dizaines,unites,diziemes);
                          sprintf(display_buffer_ligne1,"Echap -> STOP");
                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                          TIMSK=0x04; // autorisation interruption dbordement sur timer1
                            
                        }
       		      if (BP==ECHAP) etat = Arret;
                      		else etat = Marche; 
                      		
                      etat_1 = Marche;
       break;
                      
       case ReglageDebit: if (etat_1 != etat)
                          { 
                            Regdebit(&dizaines, &unites, &diziemes);
                            sprintf(display_buffer_ligne0,"Echap -> Arret");
                            sprintf(display_buffer_ligne1,"SET   -> RUN");
                            Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                          }
       		      
                      	  if (BP==ECHAP) etat = Arret;
                      		else if (BP == SET) etat = Marche;
                      		              else etat = ReglageDebit;
                      
                          etat_1 = ReglageDebit;
       break;
       
       case ChoixSeringue: if (etat_1 != etat)
                            {
                            	seringue = Select_Seringue();
                         
                         	switch(seringue)
                         	{
                         	 case 1 : sprintf(display_buffer_ligne0,"Srg=TERUMO 50CC"); break;
                         	 case 2 : sprintf(display_buffer_ligne0,"Srg=MONO/BD 50CC"); break;
                         	 case 3 : sprintf(display_buffer_ligne0,"Seringue=BD 20CC"); break;
                         	}
                         	sprintf(display_buffer_ligne1,"echp>Arr OK>RG_D"); 
                         	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                         	
                            } 
                            if (BP==ECHAP) etat = Arret;
                      		else if (BP == OK) etat = ReglageDebit;
                      		              else etat = ChoixSeringue;
                            etat_1 = ChoixSeringue;
       break;
      }

   };
}
